use aoc22::day1;
use aoc22::util;

const N_ELVES: usize = 3;

fn main() {
    let elves = day1::parse_elves(&util::parse_input());

    let max_vals = util::max_n(elves.as_slice(), N_ELVES).unwrap();
    println!(
        "The {} elves with the most calories are carrying {} cal",
        N_ELVES,
        max_vals.iter().sum::<u32>()
    );
}
